"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extendTheme = void 0;
const react_1 = require("@gluestack-style/react");
const utils_1 = require("./utils");
function extendTheme(baseNativbaseTheme) {
    console.log('function', baseNativbaseTheme);
}
exports.extendTheme = extendTheme;
const transformTheme = (componentTheme) => {
    // FIX: Remove Hook from here
    const styledContext = (0, react_1.useStyled)();
    let transformedTheme = {
        variants: {
            variant: {},
            size: {},
        },
        defaultProps: {},
    };
    const { baseStyle, variants, sizes, defaultProps } = componentTheme;
    const propsWithDollarSigns = (0, utils_1.addDollarSignsToProps)(baseStyle, styledContext.config);
    // Transforms NativeBase Properties to Gluestack
    const sxProps = (0, utils_1.convertToSXForStateColorModeMediaQuery)(propsWithDollarSigns, styledContext.config);
    transformedTheme = Object.assign(Object.assign({}, transformedTheme), sxProps);
    // Mapping variants
    if (componentTheme.variants) {
        Object.keys(variants).forEach((variant) => {
            const propsWithDollarSigns = (0, utils_1.addDollarSignsToProps)(variants[variant], styledContext.config);
            const sxProps = (0, utils_1.convertToSXForStateColorModeMediaQuery)(propsWithDollarSigns, styledContext.config);
            transformedTheme.variants.variant[variant] = sxProps;
        });
    }
    // Mapping Sizes
    if (componentTheme.sizes) {
        Object.keys(sizes).forEach((size) => {
            const propsWithDollarSigns = (0, utils_1.addDollarSignsToProps)(sizes[size], styledContext.config);
            const sxProps = (0, utils_1.convertToSXForStateColorModeMediaQuery)(propsWithDollarSigns, styledContext.config);
            transformedTheme.variants.size[size] = sxProps;
        });
    }
    // Mapping Default Props
    if (componentTheme.defaultProps) {
        const propsWithDollarSigns = (0, utils_1.addDollarSignsToProps)(defaultProps, styledContext.config);
        const sxProps = (0, utils_1.convertToSXForStateColorModeMediaQuery)(propsWithDollarSigns, styledContext.config);
        transformedTheme.defaultProps = sxProps;
    }
    return transformedTheme;
};
