"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDisclose = void 0;
const react_1 = __importDefault(require("react"));
function useDisclose(initState) {
    const [isOpen, setIsOpen] = react_1.default.useState(initState || false);
    const onOpen = () => {
        setIsOpen(true);
    };
    const onClose = () => {
        setIsOpen(false);
    };
    const onToggle = () => {
        setIsOpen(!isOpen);
    };
    return {
        isOpen,
        onOpen,
        onClose,
        onToggle,
    };
}
exports.useDisclose = useDisclose;
